#include <bits/stdc++.h>
using namespace std;
void jela(long long n,long long q,vector<long long>di,vector<long long>pi,vector<long long>kj,vector<long long>res[],long long pakovanja,long long i,long long j,long long br){

    if(br>=q){
            for(int i=0;i<q;i++){
             cout<<res[i]<<endl;
            }
        return;}
        if(i==di[j]){
    pakovanja+=pi[j];
    j++;
        }
    if(pakovanja>=0)
        res[br]+=1;
    if(i>=kj[br]){
        br++;
    }
    jela(n,q,di,pi,kj,res,pakovanja,i+1,j,br);




    }

int main()
{
    long long n, q;
    cin>>n>>q;
    vector< long long> di(n);
    vector< long long> pi(n);
    vector< long long> kj(q);
    long long pakovanja=0;
    long long i=0;//dani si ovako
    long long j=0;//dani kad je kupljena plazma
    long long br=0;//brojac
    vector< long long> res(q);
    for(int i=0;i<n;i++){
        cin>>di[i]>>pi[i];
    }
    for(int i=j;j<q;j++){
        cin>>kj[j];
    }
    jela(n,q,di,pi,kj,res,pakovanja,i,j)
    return 0;
}